diff --git a/ChangeLog b/ChangeLog
index 72fa4593e..80449e923 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -5,7 +5,9 @@
     fix HAL build #576; fix older GTK2 build
     Menu and Shift+F10 show side pane menus #575
     Design Menu shown with Menu key in addition to F2 #575
-    make keypress or click in dir tree not focus file list #541 #575
+    dir tree allow keyboard navigation, keep focus #541 #575
+    dir tree double-click expands/collapses row #542 #575
+    dir tree context menu|New|Tab Here opens selected dir
 1.0.3   2015-08-26:
     add Devices|Settings|Auto-Mount|Mount Dirs option #548
     proto hand keep %a for lxterminal urxvtc konsole gnome-terminal #552
diff --git a/src/ptk/ptk-dir-tree-view.c b/src/ptk/ptk-dir-tree-view.c
index 2b370dddb..8491136f5 100644
--- a/src/ptk/ptk-dir-tree-view.c
+++ b/src/ptk/ptk-dir-tree-view.c
@@ -434,15 +434,15 @@ gboolean on_dir_tree_view_button_press( GtkWidget* view,
                                         GdkEventButton* evt,
                                         PtkFileBrowser* browser )
 {
+    GtkTreeModel* model;
+    GtkTreePath* tree_path;
+    GtkTreeViewColumn* tree_col;
+    GtkTreeIter it;
+
     if ( evt->type == GDK_BUTTON_PRESS &&
                                     ( evt->button == 1 || evt->button == 3 ) )
     {
         // middle click 2 handled in ptk-file-browser.c on_dir_tree_button_press
-        GtkTreeModel * model;
-        GtkTreePath* tree_path;
-        GtkTreeViewColumn* tree_col;
-        GtkTreeIter it;
-
         model = gtk_tree_view_get_model( GTK_TREE_VIEW( view ) );
         if ( gtk_tree_view_get_path_at_pos( GTK_TREE_VIEW( view ),
                                             evt->x, evt->y, &tree_path,
@@ -473,6 +473,9 @@ gboolean on_dir_tree_view_button_press( GtkWidget* view,
 
                         sel_files = g_list_prepend( NULL, vfs_file_info_ref(file) );
                         dir_name = g_path_get_dirname( file_path );
+                        /* FIXME: New|Tab Here and New|File etc work on the
+                         * wrong location because dir_name is really incorrect.
+                         * But if set to cur dir it breaks Copy, etc. */
                         popup = ptk_file_menu_new( NULL, browser,
                                     file_path, file,
                                     dir_name, sel_files );
@@ -483,12 +486,31 @@ gboolean on_dir_tree_view_button_press( GtkWidget* view,
                                         NULL, NULL, 3, evt->time );
 
                         vfs_file_info_unref( file );
+                        gtk_tree_path_free( tree_path );
+                        return TRUE;
                     }
                 }
             }
             gtk_tree_path_free( tree_path );
         }
     }
+    else if ( evt->type == GDK_2BUTTON_PRESS && evt->button == 1 )
+    {
+        // double click - expand/collapse
+        if ( gtk_tree_view_get_path_at_pos( GTK_TREE_VIEW( view ),
+                                            evt->x, evt->y, &tree_path,
+                                            NULL, NULL, NULL ) )
+        {
+            if ( gtk_tree_view_row_expanded( GTK_TREE_VIEW( view ),
+                                                                tree_path ) )
+                gtk_tree_view_collapse_row( GTK_TREE_VIEW( view ), tree_path );
+            else
+                gtk_tree_view_expand_row( GTK_TREE_VIEW( view ), tree_path,
+                                                                FALSE );
+            gtk_tree_path_free( tree_path );
+            return TRUE;
+        }
+    }
     return FALSE;
 }
 
diff --git a/src/ptk/ptk-file-browser.c b/src/ptk/ptk-file-browser.c
index 5fab77017..a00ae581e 100644
--- a/src/ptk/ptk-file-browser.c
+++ b/src/ptk/ptk-file-browser.c
@@ -3917,14 +3917,10 @@ static gboolean on_dir_tree_update_sel ( PtkFileBrowser* file_browser )
         if ( strcmp( dir_path, ptk_file_browser_get_cwd( file_browser ) ) )
         {
             gdk_threads_enter(); // needed for gtk_dialog_run in ptk_show_error
-            // don't focus file list
-            file_browser->inhibit_focus = TRUE;
             if ( ptk_file_browser_chdir( file_browser, dir_path,
                                                 PTK_FB_CHDIR_ADD_HISTORY ) )
                 gtk_entry_set_text( GTK_ENTRY( file_browser->path_bar ),
                                                                 dir_path );
-            else
-                file_browser->inhibit_focus = FALSE;
             gdk_threads_leave();
         }
         g_free( dir_path );
@@ -5621,6 +5617,8 @@ static gboolean on_dir_tree_button_press( GtkWidget* view,
 
     if ( evt->type == GDK_BUTTON_PRESS && evt->button == 2 )    /* middle click */
     {
+        /* left and right click handled in ptk-dir-tree-view.c
+         * on_dir_tree_view_button_press() */
         GtkTreeModel * model;
         GtkTreePath* tree_path;
         GtkTreeIter it;
